var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var memoryIndex_1 = require("@nano-sql/core/lib/adapters/memoryIndex");
var webSQL_1 = require("@nano-sql/core/lib/adapters/webSQL");
exports.sqlite3 = require('better-sqlite3');
var SQLite = /** @class */ (function (_super) {
    __extends(SQLite, _super);
    function SQLite(fileName, sqliteOptions, batchSize) {
        var _this = _super.call(this, false, true) || this;
        _this.plugin = {
            name: "SQLite Adapter",
            version: 2.07
        };
        _this._ai = {};
        _this._query = _this._query.bind(_this);
        _this._filename = fileName || ":memory:";
        _this._args = sqliteOptions && typeof sqliteOptions !== "number" ? sqliteOptions : undefined;
        _this._tableConfigs = {};
        _this._sqlite = webSQL_1.SQLiteAbstract(_this._query, batchSize || 500);
        return _this;
    }
    SQLite.prototype.connect = function (id, complete, error) {
        this._id = id;
        try {
            this._db = new exports.sqlite3(this._filename, __assign({ memory: this._filename === ":memory:" ? true : (this._args && this._args.memory) }, (this._args || {})));
            this._sqlite.createAI(complete, error);
        }
        catch (err) {
            error(err);
        }
    };
    SQLite.prototype.createTable = function (tableName, tableData, complete, error) {
        this._tableConfigs[tableName] = tableData;
        this._sqlite.createTable(tableName, tableData, this._ai, complete, error);
    };
    SQLite.prototype._query = function (allowWrite, sql, args, onRow, complete, error) {
        var stmt = this._db.prepare(sql);
        while (true) {
            if (allowWrite) {
                try {
                    stmt.run.apply(stmt, args);
                    complete();
                    break;
                }
                catch (e) {
                    if (e.message !== 'This database connection is busy executing a query') {
                        error(e);
                        break;
                    }
                }
            }
            else {
                try {
                    var k = 0;
                    var results = stmt.all.apply(stmt, args);
                    while (k < results.length) {
                        onRow(results[k], k);
                        k++;
                    }
                    complete();
                    break;
                }
                catch (e) {
                    if (e.message !== 'This database connection is busy executing a query') {
                        error(e);
                        break;
                    }
                }
            }
        }
    };
    SQLite.prototype.dropTable = function (table, complete, error) {
        this._sqlite.dropTable(table, complete, error);
    };
    SQLite.prototype.disconnect = function (complete, error) {
        complete();
    };
    SQLite.prototype.write = function (table, pk, row, complete, error) {
        this._sqlite.write(this._tableConfigs[table].pkType, this._tableConfigs[table].pkCol, table, pk, row, this._tableConfigs[table].ai, this._ai, complete, error);
    };
    SQLite.prototype.read = function (table, pk, complete, error) {
        this._sqlite.read(table, pk, complete, error);
    };
    SQLite.prototype.delete = function (table, pk, complete, error) {
        this._sqlite.remove(table, pk, complete, error);
    };
    SQLite.prototype.readMulti = function (table, type, offsetOrLow, limitOrHigh, reverse, onRow, complete, error) {
        this._sqlite.readMulti(table, type, offsetOrLow, limitOrHigh, reverse, onRow, complete, error);
    };
    SQLite.prototype.getTableIndex = function (table, complete, error) {
        this._sqlite.getIndex(table, complete, error);
    };
    SQLite.prototype.getTableIndexLength = function (table, complete, error) {
        this._sqlite.getNumberOfRecords(table, complete, error);
    };
    return SQLite;
}(memoryIndex_1.nanoSQLMemoryIndex));
exports.SQLite = SQLite;
//# sourceMappingURL=index.js.map